
import client from "./src/client";
import ADD_EVEMT from "./src/graphql/addEvent";
import getGeoInfo from "./src/events/getGeoInfo";
import sessionStart from "./src/events/startSession";
import paegView from "./src/events/pageView";
import GET_PROJECTID_BY_ORIGIN from "./src/graphql/getProjectIdByOrigin";
import * as PusherPushNotifications from "@pusher/push-notifications-web";
import getVisitorId from "./src/refactor";
import { oneSession } from "./src/events/defaultData";


// let currentPage = window.location.href;

// setInterval(function () {
//   console.log("alive");
//   if (currentPage !== window.location.href) {
//     // page has changed, set new page as 'current'
//     currentPage = window.location.href;

//     // do your thing..
//     console.log(`URL changed to ${window.location.href}`);
//     paegView();
//   }
// }, 500);
// test();

// const endpoint = "http://localhost:4000/graphql";
// const headers = {
//   "content-type": "application/json",
//   Authorization: "<token>",
//   credentials: "include",
// };

// const graphqlMutaion = {
//   operationName: "addEvent",
//   query: `mutation addEvent($eventDate: Date!, $eventName: EventName!, $eventValue: JSON!, $deviceCategory: String, $userId: ID!, $deviceIsLimitedAdTracking: Boolean) {
//     addEvent(event_date: $eventDate, event_name: $eventName, event_value: $eventValue, device_category: $deviceCategory, userID: $userId, device_is_limited_ad_tracking: $deviceIsLimitedAdTracking)
//   }`,
//   variables: {
//     eventDate: 1658339338132,
//     eventName: "page_view",
//     eventValue: "{sadf:'asd'}",
//     deviceCategory: "null",
//     userId: "test123",
//     deviceIsLimitedAdTracking: true,
//   },
// };

const beamsClient = new PusherPushNotifications.Client({
  instanceId: 'd0893de3-7453-4aa2-88d9-134f8ce3ddfa',
});

const beamsTokenProvider = new PusherPushNotifications.TokenProvider({
  // url: "https://api.freeanalytics.one/pusher/beams-auth",
  url: "https://api.freeanalytics.one/pusher/beams-auth",
  headers: {
    credentials: "include", // Headers your auth endpoint needs
  },
});

export async function startApp() {
  console.log("Started tracking");
  try {

    const projectIdRes = await client.query({
      query: GET_PROJECTID_BY_ORIGIN,
      variables: {
        origin: window.location.origin,
      },
    });

    console.log(projectIdRes);

    const projectId = parseInt(projectIdRes.data.getProjectIdByOrigin)
    console.log("projectId", projectId);
    setInterval(() => {
      sessionStart(projectId);
    }, oneSession / 10)

    var previousUrl = "";
    var observer = new MutationObserver(function (mutations) {
      console.log("alive");
      if (window.location.href !== previousUrl) {
        previousUrl = window.location.href;
        console.log(`URL changed to ${window.location.href}`);
        paegView(projectId);
      }
    });

    const config = { subtree: true, childList: true };
    observer.observe(document, config);

    const userAgent = window.navigator.userAgent
    // console.log("browser", browser)

    // Pusher - settings notification

    // beamsClient.clearAllState().then(() => console.log('Beams state has been cleared')).catch(e => console.error('Could not clear Beams state', e));
    // beamsClient.start()
    //     .then(() => beamsClient.addDeviceInterest('hello'))
    //     .then(() => console.log('Successfully registered and subscribed!'))
    //     .catch(console.error);
    const visitorId = await getVisitorId();

    console.log(visitorId + '@' + projectId.toString())
    beamsClient
      .start()
      .then(() => beamsClient.setUserId(visitorId + '@' + projectId.toString(), beamsTokenProvider))
      .catch((error) => {
        // Error first time then clear state
        console.log("error msg:", error.message)
        if (error.message === 'Changing the `userId` is not allowed.' || error.message === 'Unexpected status code 400: Bad request, A user Id is already associated with this device.') {
          beamsClient.clearAllState()
            .then(() => console.log('Beams state has been cleared')).then(() => {
              beamsClient
                .start()
                .then(() => beamsClient.setUserId(visitorId + '@' + projectId.toString(), beamsTokenProvider))
                .catch((error) => {
                  // Error second time then clear state
                  console.log("error msg:", error.message)
                  if (error.message === 'Changing the `userId` is not allowed.' || error.message === 'Unexpected status code 400: Bad request, A user Id is already associated with this device.') {
                    beamsClient.clearAllState()
                      .then(() => console.log('Beams state has been cleared')).then(() => {
                        beamsClient
                          .start()
                          .then(() => beamsClient.setUserId(visitorId + '@' + projectId.toString(), beamsTokenProvider))
                          .catch((error) => {
                            console.log("error msg:", error.message)
                          })
                      }
                      ).catch(e => console.error('Could not clear Beams state', e));
                  }
                })
            }
            ).catch(e => console.error('Could not clear Beams state', e));
        }
      });
  } catch (error) {
    console.log("Project not found", error)
  }

};
startApp();

export function unifyUserData() {
  console.log("unifing user data")
}

