import { __assign, __awaiter, __generator } from "tslib";
/**
 * Sets new property values to the object and reverts the properties when the action is complete
 */
export default function withMockProperties(object, mockProperties, action) {
    return __awaiter(this, void 0, void 0, function () {
        var originalProperties, _i, _a, property, mockProperty, _b, _c, property, propertyDescriptor;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    originalProperties = {};
                    for (_i = 0, _a = Object.keys(mockProperties); _i < _a.length; _i++) {
                        property = _a[_i];
                        originalProperties[property] = Object.getOwnPropertyDescriptor(object, property);
                        mockProperty = mockProperties[property];
                        if (mockProperty) {
                            Object.defineProperty(object, property, __assign(__assign({}, mockProperty), { configurable: true }));
                        }
                        else {
                            delete object[property];
                        }
                    }
                    _d.label = 1;
                case 1:
                    _d.trys.push([1, , 3, 4]);
                    return [4 /*yield*/, action()];
                case 2: return [2 /*return*/, _d.sent()];
                case 3:
                    for (_b = 0, _c = Object.keys(originalProperties); _b < _c.length; _b++) {
                        property = _c[_b];
                        propertyDescriptor = originalProperties[property];
                        if (propertyDescriptor === undefined) {
                            delete object[property];
                        }
                        else {
                            Object.defineProperty(object, property, propertyDescriptor);
                        }
                    }
                    return [7 /*endfinally*/];
                case 4: return [2 /*return*/];
            }
        });
    });
}
